#include WMI.h

DATA SECTION
	// Classes
	CLSID_WbemLocator GUID GUID_CLSID_WbemLocator ;<04590f811h,01d3ah,011d0h,<89h,1fh,00h,0aah,00h,4bh,2eh,24h>>

	// Interfaces
	IID_IUnknown GUID GUID_IID_IUnknown ;<00000000h,0000h,0000h,<0C0h,00h,00h,00h,00h,00h,00h,46h>>
	IID_IWbemLocator GUID GUID_IID_IWbemLocator ;<0dc12a687h,0737fh,011cfh,<88h,4dh,00h,0aah,00h,4bh,2eh,24h>>
	IID_IWbemServices GUID GUID_IID_IWbemServices

	pNameSpace		PTR ?
	pWbemLocator	PTR ?
	pUnk			PTR ?
	pObj			PTR ?
	pEnum			PTR ?
	
	szManufacturer	CHAR	256 DUP (?)
	szModel			CHAR	256 DUP (?)

CODE SECTION
START:

	invoke GetModuleHandle,0
	mov rcx,eax

	invoke CoInitialize,NULL

	invoke GetManufacturer,offset szManufacturer,offset szModel
	invoke MessageBox,NULL,offset szModel,offset szManufacturer,NULL

	invoke CoUninitialize
	invoke ExitProcess,0

GetManufacturer FRAME pManufacturer, pModel
	LOCAL hres :%HANDLE
	LOCAL bstrNameSpace :%PTR
	LOCAL variant :%PTR


	// Connect to the desired namespace
	invoke SysAllocString,L"\\.\root\cimv2"
	mov [bstrNameSpace], eax

	invoke CoInitializeSecurity, 0,-1,0,0,RPC_C_AUTHN_LEVEL_DEFAULT,RPC_C_IMP_LEVEL_IMPERSONATE,0,EOAC_NONE,0
	mov [hres],eax

	invoke CoCreateInstance,offset CLSID_WbemLocator,NULL,CLSCTX_INPROC_SERVER,offset IID_IWbemLocator, offset pWbemLocator
	test eax,eax
	jnz >>.EXIT

	CoInvoke(pWbemLocator,IWbemLocator.ConnectServer,[bstrNameSpace],0,0,0,0,0,0,offset pNameSpace)

	test eax,eax
	jnz >>.EXIT1
	CoInvoke(pNameSpace,IWbemServices.IUnknown.QueryInterface,offset IID_IUnknown,offset pUnk)
	test eax,eax

	// Set the security for our proxy
	invoke CoSetProxyBlanket,[pNameSpace],RPC_C_AUTHN_WINNT,RPC_C_AUTHZ_NONE,0,RPC_C_AUTHN_LEVEL_DEFAULT,RPC_C_IMP_LEVEL_IMPERSONATE,0,EOAC_NONE
	invoke CoSetProxyBlanket,[pUnk],RPC_C_AUTHN_WINNT,RPC_C_AUTHZ_NONE,0,RPC_C_AUTHN_LEVEL_DEFAULT,RPC_C_IMP_LEVEL_IMPERSONATE,0,EOAC_NONE
	CoInvoke(pUnk,Unknown.Release)

	// Execute the query, just pull all of the information
	CoInvoke(pNameSpace,IWbemServices.ExecQuery,offset L"WQL", L'Select * from Win32_ComputerSystem',WBEM_FLAG_RETURN_IMMEDIATELY,NULL,offset pEnum)
	test eax,eax
	jnz >>.EXIT2

	// Step the enumeration through the class object
	CoInvoke(pEnum,IEnumWbemClassObject.Next,WBEM_INFINITE,1,offset pObj,offset hres)
	test eax,eax
	jnz >>.EXIT3

	// Get the information we want
	CoInvoke(pObj,IWbemClassObject.Get,L"Manufacturer",0,offset variant,0,0)
	test eax,eax
	jnz >.EXIT4
	// The information is in UNICODE so convert it and display it
	invoke WideCharToMultiByte,CP_ACP,NULL,[variant+8],-1,[pManufacturer],256,NULL,NULL

	CoInvoke(pObj,IWbemClassObject.Get,L"Model",0,offset variant,0,0)
	test eax,eax
	jnz >.EXIT4
	// The information is in UNICODE so convert it and display it
	invoke WideCharToMultiByte,CP_ACP,NULL,[variant+8],-1,[pModel],256,NULL,NULL

	.EXIT4
		CoInvoke(pObj,IWbemClassObject.Release)
	.EXIT3
		CoInvoke(pEnum,IEnumWbemClassObject.Release)
	.EXIT2
		CoInvoke(pNameSpace,IWbemServices.Release)
	.EXIT1
		CoInvoke(pWbemLocator,IWbemLocator.Release)
	.EXIT
	invoke SysFreeString,[bstrNameSpace]
	ret
endf
